rev-parse: add --sq-quote to shell quote arguments
[git/git.git] / git-bisect.sh
CommitLineData
8cc6a083 1#!/bin/sh
d025524d 2
243a60fb
CC
3USAGE='[help|start|bad|good|skip|next|reset|visualize|replay|log|run]'
4LONG_USAGE='git bisect help
5 print this long help message.
6git bisect start [<bad> [<good>...]] [--] [<pathspec>...]
38a47fd6
CC
7 reset bisect state and start bisection.
8git bisect bad [<rev>]
9 mark <rev> a known-bad revision.
10git bisect good [<rev>...]
11 mark <rev>... known-good revisions.
5413812f 12git bisect skip [(<rev>|<range>)...]
6ca8b977 13 mark <rev>... untestable revisions.
38a47fd6
CC
14git bisect next
15 find next bisection to test and check it out.
16git bisect reset [<branch>]
17 finish bisection search and go back to branch.
18git bisect visualize
19 show bisect status in gitk.
20git bisect replay <logfile>
21 replay bisection log.
22git bisect log
23 show bisect log.
24git bisect run <cmd>...
243a60fb
CC
25 use <cmd>... to automatically bisect.
26
27Please use "git help bisect" to get the full man page.'
d025524d 28
8f321a39 29OPTIONS_SPEC=
ae2b0f15 30. git-sh-setup
4c550686 31require_work_tree
8cc6a083 32
ce32660e
JS
33_x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
34_x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
35
e9a45d75 36sq() {
d9bffc08 37 @@PERL@@ -e '
e9a45d75
JH
38 for (@ARGV) {
39 s/'\''/'\'\\\\\'\''/g;
40 print " '\''$_'\''";
41 }
42 print "\n";
43 ' "$@"
44}
45
8cc6a083 46bisect_autostart() {
823ea121 47 test -s "$GIT_DIR/BISECT_START" || {
8cc6a083
LT
48 echo >&2 'You need to start by "git bisect start"'
49 if test -t 0
50 then
51 echo >&2 -n 'Do you want me to do it for you [Y/n]? '
52 read yesno
53 case "$yesno" in
54 [Nn]*)
55 exit ;;
56 esac
57 bisect_start
58 else
59 exit 1
60 fi
61 }
62}
63
64bisect_start() {
8cc6a083 65 #
634f2464 66 # Verify HEAD.
8cc6a083 67 #
48949a18 68 head=$(GIT_DIR="$GIT_DIR" git symbolic-ref -q HEAD) ||
ce32660e
JS
69 head=$(GIT_DIR="$GIT_DIR" git rev-parse --verify HEAD) ||
70 die "Bad HEAD - I need a HEAD"
634f2464 71
ee831f7d 72 #
634f2464 73 # Check if we are bisecting.
ee831f7d 74 #
d3e54c88 75 start_head=''
634f2464
CC
76 if test -s "$GIT_DIR/BISECT_START"
77 then
78 # Reset to the rev from where we started.
9d0cd91c 79 start_head=$(cat "$GIT_DIR/BISECT_START")
f3a186ff 80 git checkout "$start_head" -- || exit
634f2464
CC
81 else
82 # Get rev from where we start.
83 case "$head" in
84 refs/heads/*|$_x40)
85 # This error message should only be triggered by
86 # cogito usage, and cogito users should understand
87 # it relates to cg-seek.
88 [ -s "$GIT_DIR/head-name" ] &&
89 die "won't bisect on seeked tree"
90 start_head="${head#refs/heads/}"
91 ;;
92 *)
93 die "Bad HEAD - strange symbolic ref"
94 ;;
95 esac
96 fi
8cc6a083
LT
97
98 #
634f2464 99 # Get rid of any old bisect state.
8cc6a083 100 #
823ea121 101 bisect_clean_state || exit
38a47fd6
CC
102
103 #
104 # Check for one bad and then some good revisions.
105 #
106 has_double_dash=0
107 for arg; do
108 case "$arg" in --) has_double_dash=1; break ;; esac
109 done
110 orig_args=$(sq "$@")
111 bad_seen=0
d3e54c88 112 eval=''
38a47fd6
CC
113 while [ $# -gt 0 ]; do
114 arg="$1"
115 case "$arg" in
116 --)
8fe26f44 117 shift
38a47fd6
CC
118 break
119 ;;
120 *)
634f2464 121 rev=$(git rev-parse -q --verify "$arg^{commit}") || {
38a47fd6
CC
122 test $has_double_dash -eq 1 &&
123 die "'$arg' does not appear to be a valid revision"
124 break
125 }
737c74ee
CC
126 case $bad_seen in
127 0) state='bad' ; bad_seen=1 ;;
128 *) state='good' ;;
129 esac
d3e54c88 130 eval="$eval bisect_write '$state' '$rev' 'nolog'; "
8fe26f44 131 shift
38a47fd6
CC
132 ;;
133 esac
8fe26f44 134 done
38a47fd6 135
ba963de8
CC
136 #
137 # Change state.
138 # In case of mistaken revs or checkout error, or signals received,
139 # "bisect_auto_next" below may exit or misbehave.
140 # We have to trap this to be able to clean up using
141 # "bisect_clean_state".
142 #
143 trap 'bisect_clean_state' 0
144 trap 'exit 255' 1 2 3 15
145
146 #
147 # Write new start state.
148 #
ba963de8 149 echo "$start_head" >"$GIT_DIR/BISECT_START" &&
823ea121 150 sq "$@" >"$GIT_DIR/BISECT_NAMES" &&
ba963de8 151 eval "$eval" &&
6c98c054 152 echo "git bisect start$orig_args" >>"$GIT_DIR/BISECT_LOG" || exit
ba963de8
CC
153 #
154 # Check if we can proceed to the next bisect state.
155 #
38a47fd6 156 bisect_auto_next
ba963de8
CC
157
158 trap '-' 0
8cc6a083
LT
159}
160
55624f9a
CC
161bisect_write() {
162 state="$1"
163 rev="$2"
737c74ee 164 nolog="$3"
55624f9a
CC
165 case "$state" in
166 bad) tag="$state" ;;
167 good|skip) tag="$state"-"$rev" ;;
168 *) die "Bad bisect_write argument: $state" ;;
169 esac
ba963de8 170 git update-ref "refs/bisect/$tag" "$rev" || exit
f454cdc4 171 echo "# $state: $(git show-branch $rev)" >>"$GIT_DIR/BISECT_LOG"
6c98c054 172 test -n "$nolog" || echo "git bisect $state $rev" >>"$GIT_DIR/BISECT_LOG"
55624f9a
CC
173}
174
c9c4e2d5
CC
175is_expected_rev() {
176 test -f "$GIT_DIR/BISECT_EXPECTED_REV" &&
177 test "$1" = $(cat "$GIT_DIR/BISECT_EXPECTED_REV")
178}
179
180mark_expected_rev() {
181 echo "$1" > "$GIT_DIR/BISECT_EXPECTED_REV"
182}
183
184check_expected_revs() {
185 for _rev in "$@"; do
186 if ! is_expected_rev "$_rev"; then
187 rm -f "$GIT_DIR/BISECT_ANCESTORS_OK"
188 rm -f "$GIT_DIR/BISECT_EXPECTED_REV"
189 return
190 fi
191 done
192}
193
ee2314f5
CC
194bisect_skip() {
195 all=''
196 for arg in "$@"
197 do
198 case "$arg" in
199 *..*)
200 revs=$(git rev-list "$arg") || die "Bad rev input: $arg" ;;
201 *)
1a66a489 202 revs=$(sq "$arg") ;;
ee2314f5
CC
203 esac
204 all="$all $revs"
205 done
1a66a489 206 eval bisect_state 'skip' $all
ee2314f5
CC
207}
208
155fc795 209bisect_state() {
8cc6a083 210 bisect_autostart
155fc795
CC
211 state=$1
212 case "$#,$state" in
213 0,*)
214 die "Please call 'bisect_state' with at least one argument." ;;
215 1,bad|1,good|1,skip)
216 rev=$(git rev-parse --verify HEAD) ||
217 die "Bad rev input: HEAD"
c9c4e2d5
CC
218 bisect_write "$state" "$rev"
219 check_expected_revs "$rev" ;;
e3389075 220 2,bad|*,good|*,skip)
155fc795 221 shift
d3e54c88 222 eval=''
e3389075 223 for rev in "$@"
155fc795 224 do
a179a303 225 sha=$(git rev-parse --verify "$rev^{commit}") ||
e3389075 226 die "Bad rev input: $rev"
d3e54c88
CC
227 eval="$eval bisect_write '$state' '$sha'; "
228 done
c9c4e2d5
CC
229 eval "$eval"
230 check_expected_revs "$@" ;;
e3389075
CC
231 *,bad)
232 die "'git bisect bad' can take only one argument." ;;
cc9f24d0
JH
233 *)
234 usage ;;
8cc6a083 235 esac
97e1c51e
CC
236 bisect_auto_next
237}
238
8cc6a083 239bisect_next_check() {
0a5280a9
JH
240 missing_good= missing_bad=
241 git show-ref -q --verify refs/bisect/bad || missing_bad=t
242 test -n "$(git for-each-ref "refs/bisect/good-*")" || missing_good=t
6fecf191 243
0a5280a9
JH
244 case "$missing_good,$missing_bad,$1" in
245 ,,*)
246 : have both good and bad - ok
247 ;;
248 *,)
249 # do not have both but not asked to fail - just report.
250 false
251 ;;
252 t,,good)
253 # have bad but not good. we could bisect although
254 # this is less optimum.
255 echo >&2 'Warning: bisecting only with a bad commit.'
256 if test -t 0
257 then
258 printf >&2 'Are you sure [Y/n]? '
e5d3afd7
FM
259 read yesno
260 case "$yesno" in [Nn]*) exit 1 ;; esac
0a5280a9
JH
261 fi
262 : bisect without good...
263 ;;
8cc6a083 264 *)
0a5280a9 265 THEN=''
823ea121 266 test -s "$GIT_DIR/BISECT_START" || {
0a5280a9
JH
267 echo >&2 'You need to start by "git bisect start".'
268 THEN='then '
269 }
270 echo >&2 'You '$THEN'need to give me at least one good' \
271 'and one bad revisions.'
272 echo >&2 '(You can use "git bisect bad" and' \
273 '"git bisect good" for that.)'
274 exit 1 ;;
8cc6a083
LT
275 esac
276}
277
278bisect_auto_next() {
434d036f 279 bisect_next_check && bisect_next || :
8cc6a083
LT
280}
281
f821d089
CC
282bisect_checkout() {
283 _rev="$1"
284 _msg="$2"
285 echo "Bisecting: $_msg"
c9c4e2d5 286 mark_expected_rev "$_rev"
f3a186ff 287 git checkout -q "$_rev" -- || exit
f821d089
CC
288 git show-branch "$_rev"
289}
290
291is_among() {
292 _rev="$1"
293 _list="$2"
294 case "$_list" in *$_rev*) return 0 ;; esac
295 return 1
296}
297
f821d089
CC
298handle_bad_merge_base() {
299 _badmb="$1"
300 _good="$2"
c9c4e2d5 301 if is_expected_rev "$_badmb"; then
f821d089
CC
302 cat >&2 <<EOF
303The merge base $_badmb is bad.
304This means the bug has been fixed between $_badmb and [$_good].
305EOF
306 exit 3
307 else
308 cat >&2 <<EOF
309Some good revs are not ancestor of the bad rev.
310git bisect cannot work properly in this case.
311Maybe you mistake good and bad revs?
312EOF
313 exit 1
314 fi
315}
316
317handle_skipped_merge_base() {
318 _mb="$1"
319 _bad="$2"
320 _good="$3"
321 cat >&2 <<EOF
322Warning: the merge base between $_bad and [$_good] must be skipped.
323So we cannot be sure the first bad commit is between $_mb and $_bad.
324We continue anyway.
325EOF
326}
327
6a54d976
CC
328#
329# "check_merge_bases" checks that merge bases are not "bad".
330#
331# - If one is "good", that's good, we have nothing to do.
332# - If one is "bad", it means the user assumed something wrong
333# and we must exit.
334# - If one is "skipped", we can't know but we should warn.
335# - If we don't know, we should check it out and ask the user to test.
336#
337# In the last case we will return 1, and otherwise 0.
338#
f821d089
CC
339check_merge_bases() {
340 _bad="$1"
341 _good="$2"
342 _skip="$3"
343 for _mb in $(git merge-base --all $_bad $_good)
344 do
345 if is_among "$_mb" "$_good"; then
346 continue
347 elif test "$_mb" = "$_bad"; then
348 handle_bad_merge_base "$_bad" "$_good"
349 elif is_among "$_mb" "$_skip"; then
350 handle_skipped_merge_base "$_mb" "$_bad" "$_good"
351 else
f821d089 352 bisect_checkout "$_mb" "a merge base must be tested"
6a54d976 353 return 1
f821d089
CC
354 fi
355 done
6a54d976 356 return 0
f821d089
CC
357}
358
6a54d976
CC
359#
360# "check_good_are_ancestors_of_bad" checks that all "good" revs are
361# ancestor of the "bad" rev.
362#
363# If that's not the case, we need to check the merge bases.
364# If a merge base must be tested by the user we return 1 and
365# otherwise 0.
366#
f821d089 367check_good_are_ancestors_of_bad() {
c9c4e2d5
CC
368 test -f "$GIT_DIR/BISECT_ANCESTORS_OK" &&
369 return
370
f821d089
CC
371 _bad="$1"
372 _good=$(echo $2 | sed -e 's/\^//g')
373 _skip="$3"
374
375 # Bisecting with no good rev is ok
376 test -z "$_good" && return
377
378 _side=$(git rev-list $_good ^$_bad)
379 if test -n "$_side"; then
6a54d976 380 # Return if a checkout was done
c9c4e2d5 381 check_merge_bases "$_bad" "$_good" "$_skip" || return
f821d089 382 fi
c9c4e2d5
CC
383
384 : > "$GIT_DIR/BISECT_ANCESTORS_OK"
6a54d976
CC
385
386 return 0
f821d089
CC
387}
388
8cc6a083 389bisect_next() {
8fe26f44 390 case "$#" in 0) ;; *) usage ;; esac
8cc6a083 391 bisect_autostart
0a5280a9
JH
392 bisect_next_check good
393
f821d089
CC
394 # Get bad, good and skipped revs
395 bad=$(git rev-parse --verify refs/bisect/bad) &&
396 good=$(git for-each-ref --format='^%(objectname)' \
397 "refs/bisect/good-*" | tr '\012' ' ') &&
97e1c51e 398 skip=$(git for-each-ref --format='%(objectname)' \
d2d188d9 399 "refs/bisect/skip-*" | tr '\012' ' ') || exit
97e1c51e 400
f821d089 401 # Maybe some merge bases must be tested first
6a54d976
CC
402 check_good_are_ancestors_of_bad "$bad" "$good" "$skip"
403 # Return now if a checkout has already been done
404 test "$?" -eq "1" && return
f821d089 405
5a1d31c7
CC
406 # Perform bisection computation, display and checkout
407 git bisect--helper --next-exit
408 res=$?
0a5280a9 409
5a1d31c7
CC
410 # Check if we should exit because bisection is finished
411 test $res -eq 10 && exit 0
0a5280a9 412
5a1d31c7
CC
413 # Check for an error in the bisection process
414 test $res -ne 0 && exit $res
415
416 return 0
8cc6a083
LT
417}
418
cc9f24d0
JH
419bisect_visualize() {
420 bisect_next_check fail
235997c9
JH
421
422 if test $# = 0
423 then
22b3ddd5 424 case "${DISPLAY+set}${SESSIONNAME+set}${MSYSTEM+set}${SECURITYSESSIONID+set}" in
235997c9 425 '') set git log ;;
508e84a7 426 set*) set gitk ;;
235997c9
JH
427 esac
428 else
429 case "$1" in
430 git*|tig) ;;
431 -*) set git log "$@" ;;
432 *) set git "$@" ;;
433 esac
434 fi
435
e3f062bf 436 not=$(git for-each-ref --format='%(refname)' "refs/bisect/good-*")
235997c9 437 eval '"$@"' refs/bisect/bad --not $not -- $(cat "$GIT_DIR/BISECT_NAMES")
cc9f24d0
JH
438}
439
8cc6a083 440bisect_reset() {
823ea121 441 test -s "$GIT_DIR/BISECT_START" || {
fce0499f
CC
442 echo "We are not bisecting."
443 return
444 }
8cc6a083 445 case "$#" in
823ea121 446 0) branch=$(cat "$GIT_DIR/BISECT_START") ;;
737c74ee
CC
447 1) git show-ref --verify --quiet -- "refs/heads/$1" ||
448 die "$1 does not seem to be a valid branch"
8cc6a083 449 branch="$1" ;;
8fe26f44 450 *)
8cc6a083
LT
451 usage ;;
452 esac
f3a186ff 453 git checkout "$branch" -- && bisect_clean_state
e204de28
JH
454}
455
38a47fd6 456bisect_clean_state() {
947a604b 457 # There may be some refs packed during bisection.
634f2464 458 git for-each-ref --format='%(refname) %(objectname)' refs/bisect/\* |
947a604b
CC
459 while read ref hash
460 do
823ea121 461 git update-ref -d $ref $hash || exit
947a604b 462 done
c9c4e2d5
CC
463 rm -f "$GIT_DIR/BISECT_EXPECTED_REV" &&
464 rm -f "$GIT_DIR/BISECT_ANCESTORS_OK" &&
823ea121
CC
465 rm -f "$GIT_DIR/BISECT_LOG" &&
466 rm -f "$GIT_DIR/BISECT_NAMES" &&
467 rm -f "$GIT_DIR/BISECT_RUN" &&
9d0cd91c 468 # Cleanup head-name if it got left by an old version of git-bisect
823ea121
CC
469 rm -f "$GIT_DIR/head-name" &&
470
471 rm -f "$GIT_DIR/BISECT_START"
38a47fd6
CC
472}
473
e204de28 474bisect_replay () {
737c74ee 475 test -r "$1" || die "cannot read $1 for replaying"
e204de28 476 bisect_reset
6c98c054 477 while read git bisect command rev
e204de28 478 do
6c98c054
MV
479 test "$git $bisect" = "git bisect" -o "$git" = "git-bisect" || continue
480 if test "$git" = "git-bisect"; then
481 rev="$command"
482 command="$bisect"
483 fi
e204de28
JH
484 case "$command" in
485 start)
e9a45d75 486 cmd="bisect_start $rev"
737c74ee
CC
487 eval "$cmd" ;;
488 good|bad|skip)
489 bisect_write "$command" "$rev" ;;
e204de28 490 *)
737c74ee 491 die "?? what are you talking about?" ;;
e204de28
JH
492 esac
493 done <"$1"
494 bisect_auto_next
8cc6a083
LT
495}
496
a17c4101 497bisect_run () {
83020120
CC
498 bisect_next_check fail
499
a17c4101
CC
500 while true
501 do
502 echo "running $@"
503 "$@"
504 res=$?
505
506 # Check for really bad run error.
507 if [ $res -lt 0 -o $res -ge 128 ]; then
508 echo >&2 "bisect run failed:"
509 echo >&2 "exit code $res from '$@' is < 0 or >= 128"
510 exit $res
511 fi
512
155fc795 513 # Find current state depending on run success or failure.
71b0251c
CC
514 # A special exit code of 125 means cannot test.
515 if [ $res -eq 125 ]; then
516 state='skip'
517 elif [ $res -gt 0 ]; then
155fc795 518 state='bad'
a17c4101 519 else
155fc795 520 state='good'
a17c4101
CC
521 fi
522
155fc795
CC
523 # We have to use a subshell because "bisect_state" can exit.
524 ( bisect_state $state > "$GIT_DIR/BISECT_RUN" )
a17c4101
CC
525 res=$?
526
527 cat "$GIT_DIR/BISECT_RUN"
528
71b0251c
CC
529 if grep "first bad commit could be any of" "$GIT_DIR/BISECT_RUN" \
530 > /dev/null; then
531 echo >&2 "bisect run cannot continue any more"
532 exit $res
533 fi
534
a17c4101
CC
535 if [ $res -ne 0 ]; then
536 echo >&2 "bisect run failed:"
155fc795 537 echo >&2 "'bisect_state $state' exited with error code $res"
a17c4101
CC
538 exit $res
539 fi
540
541 if grep "is first bad commit" "$GIT_DIR/BISECT_RUN" > /dev/null; then
542 echo "bisect run success"
543 exit 0;
544 fi
545
546 done
547}
548
549
8cc6a083
LT
550case "$#" in
5510)
552 usage ;;
553*)
554 cmd="$1"
555 shift
556 case "$cmd" in
243a60fb
CC
557 help)
558 git bisect -h ;;
8cc6a083
LT
559 start)
560 bisect_start "$@" ;;
ee2314f5 561 bad|good)
155fc795 562 bisect_state "$cmd" "$@" ;;
ee2314f5
CC
563 skip)
564 bisect_skip "$@" ;;
8cc6a083
LT
565 next)
566 # Not sure we want "next" at the UI level anymore.
567 bisect_next "$@" ;;
235997c9 568 visualize|view)
cc9f24d0 569 bisect_visualize "$@" ;;
8cc6a083
LT
570 reset)
571 bisect_reset "$@" ;;
e204de28
JH
572 replay)
573 bisect_replay "$@" ;;
574 log)
575 cat "$GIT_DIR/BISECT_LOG" ;;
a17c4101
CC
576 run)
577 bisect_run "$@" ;;
8cc6a083
LT
578 *)
579 usage ;;
580 esac
581esac